#include <gtk/gtk.h>
#include "fonts.h"

#include <string.h>
#include <stdio.h>

void
virt_set_font(GtkWidget * widget, gchar * font_name)
{
    GdkFont        *font=NULL;
    GtkStyle       *style;

    if (font_name != NULL)
	font = gdk_font_load(font_name);
    if (font == NULL) {
	fprintf(stderr, "can't load font %s , using default\n", font_name);
	font = gdk_font_load(DS_FONT);
    }
    if (font != NULL) {
      style = gtk_style_copy(gtk_widget_get_style(widget));
      gdk_font_unref(style->font);
      style->font = font;
      gdk_font_ref(style->font);
      gtk_widget_set_style(widget, style);
    } else fprintf(stderr, "can't load default font .. have problems?\n");
}
