#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "iface.h"

/* from main.c */
extern GtkWidget *window;
extern int enable_ktop;
extern int enable_ktop_nk;
extern struct key_top_list virt_ktl;
/* end */

GtkStyle  *style;
static char *keytop[] = {
"tilda", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "minus", "equal", "back_slash", "bs", "tab", "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", "ob", "cb", "caps_lock", "a", "s", "d", "f", "g", "h", "j", "k", "l", "semicolon", "quote", "d_e", "l_shift", "z", "x", "c", "v", "b", "n", "m", "lt", "gt", "slash", "r_shift", "l_ctralt", "space", "r_ctralt" };

static char *rus_hash="/\0";
static char *eng_hash="`qwertyuiop[]asdfghjkl;'zxcvbnm,./\0";

int
from_rus_to_eng(int rus_val) {
  return eng_hash[(int)index(rus_hash, rus_val)-(int)rus_hash];
}
  
/* convert string from keytop[] to name used in key_top_list.?_name */
int
name_to_keyval(char *keystr) {
  if (strlen(keystr) == 1) return keystr[0];

  if (strcmp(keystr, "space") == 0) return ' ';
  if (strcmp(keystr, "slash") == 0) return '/';
  if (strcmp(keystr, "ob") == 0) return '[';
  if (strcmp(keystr, "cb") == 0) return ']';
  if (strcmp(keystr, "semicolon") == 0) return ';';
  if (strcmp(keystr, "quote") == 0) return '\'';
  if (strcmp(keystr, "tilda") == 0) return '`';
  if (strcmp(keystr, "minus") == 0) return '-';
  if (strcmp(keystr, "equal") == 0) return '=';
  if (strcmp(keystr, "lt") == 0) return ',';
  if (strcmp(keystr, "gt") == 0) return '.';
  if (strcmp(keystr, "r_shift") == 0) return R_SHIFT;
  if (strcmp(keystr, "l_shift") == 0) return L_SHIFT;
  return -1;
}
 

/*
 * gcol is int in form 0x00RRGGBB 
 */
void
virt_set_color(GtkWidget * wid, int color)
{
    GdkColor        gcol;
    GdkColormap    *cmap;

    cmap = gdk_colormap_get_system();
    gcol.red = (guint16) (((color & 0x00FF0000) >> 16) * 0x101);
    gcol.green = (guint16) (((color & 0x0000FF00) >> 8) * 0x101);
    gcol.blue = (guint16) ((color & 0x000000FF) * 0x101);
    if (!gdk_color_alloc(cmap, &gcol)) {
	g_error("couldn't allocate color");
    }
}

void
virt_error(char *message, char *label)
{
    GtkWidget      *dialog;
    GtkWidget      *prompt_label;
    GtkWidget      *button;

    dialog = gtk_dialog_new();
    gtk_container_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),
			       10);

    prompt_label = gtk_label_new(message);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), prompt_label,
		       TRUE, TRUE, 5);
    gtk_widget_show(prompt_label);

    button = gtk_button_new_with_label(label);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(destroy), NULL);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button,
		       TRUE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
    gtk_widget_grab_default(button);
    gtk_widget_show(button);
    gtk_widget_show(dialog);
    gtk_grab_add(dialog);
}

void
destroy(GtkWidget *wid, gpointer data)
{
  if (data != NULL) {
    gtk_widget_destroy(wid);
    return;
  }
  gtk_main_quit();
}


/* keytop routines */
GtkWidget *
virt_create_key(char *key, struct key_top_list *ktl) {
    GtkWidget *button;
    GtkWidget *pixmap;
    GtkWidget *box1;
    GdkPixmap *pix;
    GdkBitmap *mask;
    char key_name[256];

    button = gtk_button_new ();
    gtk_widget_set_sensitive(button, TRUE);
    gtk_widget_set_name(button, "keytopb");
    strncpy(key_name, PREFIX "/share/virt/keytop/", 200);
    strncat(key_name, key, 50);
    strncat(key_name, ".xpm", 4);
    pix = gdk_pixmap_create_from_xpm(window->window, &mask, &style->bg[GTK_STATE_NORMAL], key_name);
    pixmap = gtk_pixmap_new(pix, mask);
    box1 = gtk_hbox_new(TRUE, 0);
    gtk_container_add (GTK_CONTAINER (button), box1);
    gtk_box_pack_start(GTK_BOX(box1), pixmap, FALSE, FALSE, 0);
    gtk_widget_show(box1);
    gtk_widget_show(pixmap);
    /*   rc      */
    gtk_widget_show(button);

    ktl->wid = button;
    ktl->e_name = name_to_keyval(key);

    return button;
}

GtkWidget *
virt_keytop(struct key_top_list *head) {
  int i;
  GtkWidget *hbox, *vbox, *key;
  struct key_top_list *old_ktl;

  old_ktl = head;

  vbox = gtk_vbox_new(FALSE, 0);
  style = gtk_widget_get_style(window);

  hbox = gtk_hbox_new(FALSE, 0);
  for(i=0;i<15;i++) {
      key =  virt_create_key(keytop[i], head);
      head->next = malloc(sizeof(struct key_top_list));
      head = head->next;
      gtk_box_pack_start(GTK_BOX(hbox), key, FALSE, FALSE, 0);
      gtk_widget_show(key);
  }
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  for(;i<28;i++) {
    key =  virt_create_key(keytop[i], head);
    head->next = malloc(sizeof(struct key_top_list));
    head = head->next;
    gtk_box_pack_start(GTK_BOX(hbox), key, FALSE, FALSE, 0);
    gtk_widget_show(key);
  }
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  for(;i<41;i++) {
    key =  virt_create_key(keytop[i], head);
    head->next = malloc(sizeof(struct key_top_list));
    head = head->next;
    gtk_box_pack_start(GTK_BOX(hbox), key, FALSE, FALSE, 0);
    gtk_widget_show(key);
  }
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  for(;i<53;i++) {
    key =  virt_create_key(keytop[i], head);
    head->next = malloc(sizeof(struct key_top_list));
    head = head->next;
    gtk_box_pack_start(GTK_BOX(hbox), key, FALSE, FALSE, 0);
    gtk_widget_show(key);
  }
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  for(;i<56;i++) {
    key =  virt_create_key(keytop[i], head);
    if (i < 55) {
      head->next = malloc(sizeof(struct key_top_list));
      head = head->next;
    } else {
      head->next = old_ktl;
      head = old_ktl;
    }
    gtk_box_pack_start(GTK_BOX(hbox), key, FALSE, FALSE, 0);
    gtk_widget_show(key);
  }
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  return vbox;
}


int
virt_tolower(int *keyval) {    /*  */
  char *ind;
  static char rus_upcas_l[]="";
  static char rus_locas_l[]="";
  static char rus_upcas_r[]="";
  static char rus_locas_r[]="";
  static char eng_upcas_l[]="QWERTASDFGZXCVB";
  static char eng_locas_l[]="qwertasdfgzxcvb";
  static char eng_upcas_r[]="YUIOPHJKLNM";
  static char eng_locas_r[]="yuiophjklnm";

  if ((ind = index(eng_upcas_l, *keyval)) != NULL) {
    *keyval = eng_locas_l[ind-eng_upcas_l];
    return R_SHIFT;           /* 1: left shift */
  } else if ((ind = index(eng_upcas_r, *keyval)) != NULL) {
    *keyval = eng_locas_r[ind-eng_upcas_r];
    return L_SHIFT;           /* 2: right shift */
  } else if ((ind = index(rus_upcas_l, *keyval)) != NULL) {
    *keyval = rus_locas_l[ind - rus_upcas_l];
    return R_SHIFT;
  } else if ((ind = index(rus_upcas_r, *keyval)) != NULL) {
    *keyval = rus_locas_r[ind - rus_upcas_r];
    return L_SHIFT;
  }
  switch (*keyval) {
  case '~': *keyval = '`';
     return R_SHIFT;
  case '!': *keyval = '1';
    return R_SHIFT;
  case '@': *keyval = '2';
    return R_SHIFT;
  case '#': *keyval = '3';
    return R_SHIFT;
  case '$': *keyval = '4';
    return R_SHIFT;
  case '%': *keyval = '5';
    return R_SHIFT;
  case '^': *keyval = '6';
  }
  switch (*keyval) {
  case '&': *keyval = '7';
    return L_SHIFT;
  case '*': *keyval = '8';
    return L_SHIFT;
  case '(': *keyval = '9';
    return L_SHIFT;
  case ')': *keyval = '0';
    return L_SHIFT;
  case '_': *keyval = '-';
    return L_SHIFT;
  case '+': *keyval = '=';
    return L_SHIFT;
  case '|': *keyval = '\\';
    return L_SHIFT;
  case ':': *keyval = ';';
    return L_SHIFT;
  case '"': *keyval = '\'';
    return L_SHIFT;
  case '?': *keyval = '/';
    return L_SHIFT;
  }

  return 12345;
}

void
virt_ktop_key(int keyval, int state) { /* state = 0(leave) else (enter) */
  struct key_top_list *temp_ktl;
  int i, shift;

  shift = virt_tolower(&keyval);
  temp_ktl = &virt_ktl;
  for (i=0; i<56;i++) {
    if (keyval < 0) keyval += 256;
    if (keyval > 127) keyval = from_rus_to_eng(keyval);
    if ((temp_ktl->e_name == keyval) || (temp_ktl->e_name == shift)) {
      switch (state) {
      case 0: {
	gtk_button_leave(GTK_BUTTON(temp_ktl->wid));
	break;
      }
      default: gtk_button_enter(GTK_BUTTON(temp_ktl->wid));
      }
    }
    temp_ktl = temp_ktl->next;
  }
}
