#include <gtk/gtk.h>
#include <stdio.h>

#include "virt.h"
#include "numbers.h"

static char    *n_zero[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaa``",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`````````",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "`````````"
};
static char    *n_one[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` s ledbg c None",
    "a s ledfg c #CA1E1C",
    /*
     * pixels 
     */
    "`````````",
    "````a````",
    "````a````",
    "````a````",
    "````a````",
    "````a````",
    "`````````",
    "````a````",
    "````a````",
    "````a````",
    "````a````",
    "````a````",
    "`````````"
};
static char    *n_two[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "``aaaaa``",
    "`a```````",
    "`a```````",
    "`a```````",
    "`a```````",
    "``aaaaa``",
    "`````````"
};
/*
 * XPM 
 */
static char    *n_three[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "`aaaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "``aaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "`aaaaaa``",
    "`````````"
};
static char    *n_four[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "`````````"
};
static char    *n_five[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaaa`",
    "`a```````",
    "`a```````",
    "`a```````",
    "`a```````",
    "``aaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "`aaaaaa``",
    "`````````"
};
static char    *n_six[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaaa`",
    "`a```````",
    "`a```````",
    "`a```````",
    "`a```````",
    "``aaaaa``",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "`````````"
};
static char    *n_seven[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "`aaaaaaa`",
    "```````a`",
    "```````a`",
    "``````a``",
    "``````a``",
    "`````````",
    "`````a```",
    "`````a```",
    "````a````",
    "````a````",
    "````a````",
    "`````````"
};
static char    *n_eight[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaa``",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "`````````"
};
static char    *n_nine[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #CA1E1C s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "``aaaaa``",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "`a`````a`",
    "``aaaaa``",
    "```````a`",
    "```````a`",
    "```````a`",
    "```````a`",
    "`aaaaaa``",
    "`````````"
};
static char    *n_dot[] = {
    /*
     * width height ncolors chars_per_pixel 
     */
    "9 13 2 1",
    /*
     * colors 
     */
    "` c None    s ledbg",
    "a c #000000 s ledfg",
    /*
     * pixels 
     */
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "`````````",
    "```aaa```",
    "```aaa```",
    "`````````",
    "`````````"
};

char          **numbers[] = { n_zero, n_one, n_two,
    n_three, n_four, n_five,
    n_six, n_seven, n_eight,
    n_nine, n_dot
};

struct virt_pstat
print_num(float numb, char *color)
{
    struct virt_pstat vsp;
    GtkWidget      *box;
    GdkPixmap      *num_pixmap;
    GdkBitmap      *mask;
    GtkStyle       *style;
    char          **xpm_name;	/* pinter to apopriate pixmap */
    int             i,
                    coun = 0,
                    numbi;

    vsp.wid = box = gtk_hbox_new(FALSE, 0);
    style = gtk_widget_get_style(window);

    if (numb != (int) numb) {
	xpm_name = numbers[(int) ((numb - (int) numb) * 100) % 10];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	vsp.pixmaps[0] = gtk_pixmap_new(num_pixmap, mask);

	xpm_name = numbers[(int) ((numb - (int) numb) * 100) / 10];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	vsp.pixmaps[1] = gtk_pixmap_new(num_pixmap, mask);

	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) n_dot);
	vsp.pixmaps[2] = gtk_pixmap_new(num_pixmap, mask);
	coun = 3;
    }
    /*
     * convert integer to array of respectively pixmaps 
     */
    numbi = (int) numb;
    do {
	i = numbi % 10;
	xpm_name = numbers[i];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	vsp.pixmaps[coun++] = gtk_pixmap_new(num_pixmap, mask);
	numbi /= 10;
    } while ((numbi > 0) && (coun < VIRT_STAT_LEN));
    /*
     * end conversion here 
     */
    vsp.coun = coun - 1;

    /*
     * note: that we fill box from right to left because * of numb % 10 
     */
    for (i = 0; i < coun; i++) {
	gtk_box_pack_end(GTK_BOX(box), vsp.pixmaps[i], FALSE, FALSE, 0);
	gtk_widget_show(vsp.pixmaps[i]);
    }

    return (vsp);
}

void
update_num(struct virt_pstat *vsp, float numb, char *color)
{
    GdkPixmap      *num_pixmap;
    GdkBitmap      *mask;
    GtkStyle       *style;
    char          **xpm_name;	/* pinter to apopriate pixmap */
    int             i,
                    numbi,
                    ret_cn,
                    coun = 0,
                    numb_len = 0;

    numbi = (int) numb;
    do {
	numbi = numbi / 10;
	numb_len++;
    } while (numbi > 0);

    style = gtk_widget_get_style(window);

    if (numb != (int) numb) {
	xpm_name = numbers[(int) ((numb - (int) numb) * 100) % 10];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	if (vsp->coun >= 0) {
	    gtk_pixmap_set(GTK_PIXMAP(vsp->pixmaps[0]), num_pixmap, mask);
	} else {
	    vsp->pixmaps[0] = gtk_pixmap_new(num_pixmap, mask);
	    gtk_box_pack_end(GTK_BOX(vsp->wid), vsp->pixmaps[0], FALSE,
			     FALSE, 0);
	    gtk_widget_show(vsp->pixmaps[0]);
	}

	xpm_name = numbers[(int) ((numb - (int) numb) * 100) / 10];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	if (vsp->coun >= 1) {
	    gtk_pixmap_set(GTK_PIXMAP(vsp->pixmaps[1]), num_pixmap, mask);
	} else {
	    vsp->pixmaps[1] = gtk_pixmap_new(num_pixmap, mask);
	    gtk_box_pack_end(GTK_BOX(vsp->wid), vsp->pixmaps[1], FALSE,
			     FALSE, 0);
	    gtk_widget_show(vsp->pixmaps[1]);
	}
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) n_dot);
	if (vsp->coun >= 2) {
	    gtk_pixmap_set(GTK_PIXMAP(vsp->pixmaps[2]), num_pixmap, mask);
	} else {
	    vsp->pixmaps[2] = gtk_pixmap_new(num_pixmap, mask);
	    gtk_box_pack_end(GTK_BOX(vsp->wid), vsp->pixmaps[2], FALSE,
			     FALSE, 0);
	    gtk_widget_show(vsp->pixmaps[2]);
	}
	coun = 3;
	numb_len += 3;
    }

    numbi = (int) numb;
    do {
	i = numbi % 10;
	xpm_name = numbers[i];
	if (color != NULL)
	    xpm_name[2] = color;	/* change 'a' color of pixmap */
	num_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
						  &style->
						  bg[GTK_STATE_NORMAL],
						  (gchar **) xpm_name);
	if (vsp->coun >= coun) {
	    gtk_pixmap_set(GTK_PIXMAP(vsp->pixmaps[coun]), num_pixmap,
			   mask);
	} else {
	    vsp->pixmaps[coun] = gtk_pixmap_new(num_pixmap, mask);
	    gtk_box_pack_end(GTK_BOX(vsp->wid), vsp->pixmaps[coun], FALSE,
			     FALSE, 0);
	    gtk_widget_show(vsp->pixmaps[coun]);
	}
	numbi /= 10;
	coun++;
    } while ((numbi > 0) && (coun < VIRT_STAT_LEN));
    ret_cn = coun - 1;
    while (vsp->coun > numb_len - 1) {
	gtk_widget_destroy(vsp->pixmaps[coun++]);
	vsp->coun--;
    }
    vsp->coun = ret_cn;
}
