#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include "virt.h"
#include "iface.h"
#include "text.h"

int             exercises;	/* how many exercises; extern for main.c */

/*
 * open file with strings and fill virt_slist structures word continue; in 
 * for loop means that we do NOT need to allocate some memory for str
 * instead of it we overwrite existing str witch contains some shit like
 * "TEXT:\n" or "ENDEX.\n" 
 */
struct virt_slist *
virt_open_file(char *filename)
{
    FILE           *fd;
    struct virt_slist *vsl = NULL,
                   *ret_vsl;
    int             status = 0,
                    h_len,
                    i,
                    exs;
    char           *str;
    char            err_str[128];


    if ((fd = fopen(filename, "r")) == NULL) {
	snprintf(err_str, 128, "can't open %s file", filename);
	virt_error(err_str, "OK");
	return NULL;
    }

    /*
     * some init before filling 
     */
    exs = 0;
    str = (char *) malloc(STR_LEN);
    vsl = malloc(sizeof(struct virt_slist));
    ret_vsl = vsl;

    for (i = 0; fgets(str, STR_LEN, fd) != NULL;) {
        int ch;

	if (status == 0) {	/* initialize all */
	    vsl->chars = 0;
	    vsl->header = (char *) malloc(HEADER_LEN);
	    memset(vsl->header, 0, HEADER_LEN);
	    memset(vsl->header, '\0', HEADER_LEN);	/* for
							 * strlen(vsl->header) 
							 */
	    status = 1;
	}
	if (strcmp(str, "TEXT:\n") == 0) {
	    status = 2;
	    continue;
	} else if (strcmp(str, "ENDEX.\n") == 0) {
	    exs++;		/* noew we have complette exercise */
	    vsl->q_strs = i;
            if ((ch = getc(fd))!=EOF) {
              ungetc(ch, fd);
	      status = 0;
	      i = 0;
	      vsl->next = malloc(sizeof(struct virt_slist));
	      vsl = vsl->next;
	      continue;
            } else break;
	}
	if (status == 1) {
	    h_len = HEADER_LEN - strlen(vsl->header) - strlen(str);
	    if (h_len > 0)
		strcat(vsl->header, str);
	    continue;
	}
	if ((status == 2) && (i < MAX_STRS_IN_EX)) {
	    int             len;
	    len = strlen(str);
	    str = (char *) realloc(str, len);
	    str[len - 1] = '\0';
	    vsl->strings[i] = str;
	    vsl->chars += strlen(str);
	    i += 1;
	}
	str = (char *) malloc(STR_LEN);
    }
    free(str);
    if (feof(fd)!=0) {
      fclose(fd);
      vsl->next = ret_vsl;
      exercises = exs;
      return ret_vsl;
    }
    fclose(fd);
    fprintf(stderr, "error occured, %d\n", errno);
    return NULL;
}

/*
 * read config file $HOME/.virtrc or ./.virtrc 
 */
void
virt_ruc(struct virt_user_stats *vus)
{
    FILE           *fd;
    char            conf_f[256];

    if (!((getenv("HOME") == NULL) || (strlen(getenv("HOME")) > 200))) {
	strcpy(conf_f, getenv("HOME"));
	if (conf_f[strlen(conf_f) - 1] != '/')
	    strcat(conf_f, "/");
	strcat(conf_f, ".virtrc");
    } else			/* unable to read $HOME, assuming current
				 * directory */
	strcpy(conf_f, ".virtrc");

    if ((fd = fopen(conf_f, "r")) == NULL) {
	vus->ex = 0;
	vus->skill = 0;
	fprintf(stderr, "%s: %s\n", conf_f, strerror(errno));
	return;
    } else {
	vus->ex = getc(fd);
	vus->skill = getc(fd);
        if (vus->skill > 2) vus->skill = 2;
    }
    fclose(fd);
}

/*
 * write currex and skill to $HOME/.virtrc or ./.virtrc 
 */
void
virt_wuc(struct virt_user_stats *vus)
{
    FILE           *fd;
    char            conf_f[256];

    if (!((getenv("HOME") == NULL) || (strlen(getenv("HOME")) > 200))) {
	strcpy(conf_f, getenv("HOME"));
	if (conf_f[strlen(conf_f) - 1] != '/')
	    strcat(conf_f, "/");
	strcat(conf_f, ".virtrc");
    } else			/* unable to read $HOME, assuming current
				 * directory */
	strcpy(conf_f, ".virtrc");

    if ((fd = fopen(conf_f, "w")) == NULL) {
	fprintf(stderr, "can't open file %s\n", conf_f);
	return;
    } else {
	putc(vus->ex , fd);
	putc(vus->skill, fd);
    }
    fclose(fd);
}
