#include <sys/time.h>
#include "time.h"

struct timeval
diff_time(struct timeval first, struct timeval second)
{
    struct timeval  ret;

    if (second.tv_sec > first.tv_sec) {
	ret.tv_sec = second.tv_sec - first.tv_sec;
	ret.tv_usec = second.tv_usec - first.tv_usec;
	if (ret.tv_usec < 0) {
	    ret.tv_usec = -ret.tv_usec;
	    ret.tv_sec--;
	}
    } else if (second.tv_sec == first.tv_sec) {
	ret.tv_sec = 0;
	ret.tv_usec = second.tv_usec - first.tv_usec;
	if (ret.tv_usec < 0)
	    ret.tv_usec = -ret.tv_usec;
    } else {
	ret.tv_sec = first.tv_sec - second.tv_sec;
	ret.tv_usec = first.tv_usec - second.tv_usec;
	if (ret.tv_usec < 0) {
	    ret.tv_usec = -ret.tv_usec;
	    ret.tv_sec--;
	}
    }
    return ret;
}

int
compare_time(struct timeval fir, struct timeval sec)
{

    if (fir.tv_sec > sec.tv_sec)
	return 1;
    if (fir.tv_sec == sec.tv_sec) {
	if (fir.tv_usec > sec.tv_usec)
	    return 1;
	if (fir.tv_usec == sec.tv_usec)
	    return 0;
	else
	    return 2;
    }
    return 2;
}

struct timeval
add_time(struct timeval fir, struct timeval sec)
{
    struct timeval  ret;

    ret.tv_sec = fir.tv_sec + sec.tv_sec;
    ret.tv_usec = fir.tv_usec + sec.tv_usec;
    if (ret.tv_usec > 999999) {
	ret.tv_usec = ret.tv_usec % 1000000;
	ret.tv_sec++;
    }
    return ret;
}

struct timeval
div_time(struct timeval tim, float divv)
{
    struct timeval  ret;
    float           t;

    t = (tim.tv_sec + tim.tv_usec / 1000000.0) / divv;
    ret.tv_sec = (long) t;
    ret.tv_usec = (long) ((t - (long) t) * 1000000);
    return ret;
}
